#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <cstring>
#include "SDL.h"
#include "SDL_image.h"
#include "ImageIO.h"

using namespace std;




	SDL_Surface* ImageIO::loadImage(string filename ) 
	{ 
		//The image that's loaded 
		SDL_Surface* loadedImage = NULL; 
		//The optimized image that will be used 
		SDL_Surface* optimizedImage = NULL; 
		//Load the image using SDL_image 
		loadedImage = IMG_Load( filename.c_str() ); 
		//If the image loaded 
		if( loadedImage != NULL ) 
		{ 
			//Create an optimized image 
			optimizedImage = SDL_DisplayFormat( loadedImage ); 
			//Free the old image 
			SDL_FreeSurface( loadedImage ); 
		} 
		//Return the optimized image 
		return optimizedImage; 
	}
	
	SDL_Surface* ImageIO::loadTransparentImage(string filename ) 
	{ 
		//The image that's loaded 
		SDL_Surface* loadedImage = NULL; 
		//The optimized image that will be used 
		SDL_Surface* optimizedImage = NULL; 
		//Load the image using SDL_image 
		loadedImage = IMG_Load( filename.c_str() ); 
		//If the image loaded 
		if( loadedImage != NULL ) 
		{ 
			//Create an optimized image 
			optimizedImage = SDL_DisplayFormat( loadedImage ); 
			//Free the old image 
			SDL_FreeSurface( loadedImage );
			
			if( optimizedImage != NULL )
        	{
            	//Map the color key
            	Uint32 colorkey = SDL_MapRGB( optimizedImage->format, 0xFF, 0xFF, 0xFF );
            
            	//Set all pixels of color R 0, G 0xFF, B 0xFF to be transparent
            	SDL_SetColorKey( optimizedImage, SDL_RLEACCEL | SDL_SRCCOLORKEY, colorkey );
        	}
			 
		} 
		//Return the optimized image 
		return optimizedImage; 
	}
	
	



