

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <iostream>
#include <fstream>
#include <cstring>
#include <vector>


#include "SDL.h"
#include "consts.h"
#include "ImageIO.h"
#include "ScreenUtilities.h"
#include "cEnviroMan.h"
#include "Utils.h"

#include "SDL_gfxPrimitives.h"

using namespace std;


struct HiData 
{
       int score;
       char name[4];
};

bool comparex(const HiData& x,const HiData& y)
{
     return x.score > y.score;
}
  
int main(int argc, char *argv[])
{
    srand( (unsigned)time( NULL ) );
	SDL_Surface *screen;
	SDL_Joystick *joystick;
	SDL_Event event;
	
	int done = 0;
	int i = 1;
	int time = 0;
	
	ImageIO iio;
	ScreenUtilities utils;
	Utils ut;
	EnviroMan eman;
	
	vector<HiData> hiscore;
	ifstream fin;
	ofstream fout;
    fin.open(HISCORE_PATH);
	int y = 2; char buf[80]; int tmp=0;
	
    while ( fin.getline(buf,80) )
	{
          if ( y%2 == 0  )
          {
               tmp = atoi(buf);
          }
          else
          {
              HiData hd;
              hd.score = tmp;
              strcpy(hd.name,buf);
              hd.name[3]='\0';
              hiscore.push_back(hd);
          }
          y+=1;
    }
	fin.close();
	sort(hiscore.begin(),hiscore.end(),comparex);
	

//GP2X
  if (SDL_Init(SDL_INIT_VIDEO | SDL_INIT_JOYSTICK) < 0) {  return 1;}

    //if (SDL_Init( SDL_INIT_VIDEO )<0)  {cout<<"Video mode initialization FAILED !";return 1;}

    screen = SDL_SetVideoMode(320, 240, 16, SDL_SWSURFACE);
	if (!screen){	fprintf(stderr, "Couldn't set video mode: %s\n", SDL_GetError());  	return 1; }

//GP2X	
	joystick = SDL_JoystickOpen(0);


	SDL_Surface* charact = iio.loadTransparentImage(CHAR_PATH);	
    SDL_Surface* end_portal = iio.loadTransparentImage(ENDPORTAL_PATH);	
    SDL_Surface* bitmap = iio.loadImage(PATH_BACKGROUND);
    SDL_Surface* bonus_blue = iio.loadTransparentImage(BBONUS_PATH);
    SDL_Surface* bonus_orange = iio.loadTransparentImage(OBONUS_PATH);    
    SDL_Surface* bonus_red = iio.loadTransparentImage(RBONUS_PATH);
    SDL_Surface* bonus_green = iio.loadTransparentImage(GBONUS_PATH);
    SDL_Surface* enemy1 = iio.loadTransparentImage(ENEMY1_PATH);
    SDL_Surface* enemy2 = iio.loadTransparentImage(ENEMY2_PATH);
    SDL_Surface* enemy3 = iio.loadTransparentImage(ENEMY3_PATH);
    SDL_Surface* intro = iio.loadTransparentImage(INTRO_PATH);
    SDL_Surface* menu = iio.loadTransparentImage(MENU_PATH);
    SDL_Surface* namescreen = iio.loadTransparentImage(NAME_PATH);
    
    SDL_ShowCursor(SDL_DISABLE);
    SDL_EnableKeyRepeat(SDL_DEFAULT_REPEAT_DELAY, SDL_DEFAULT_REPEAT_INTERVAL);
    
    //name screen
    utils.drawSprite(namescreen, screen, 0, 0, 0, 0, namescreen->w, namescreen->h);
    SDL_Flip(screen);
    SDL_Delay(4000);
    
    // intro screen
    utils.drawSprite(intro, screen, 0, 0, 0, 0, intro->w, intro->h);
    SDL_Flip(screen);
    SDL_Delay(4000);
    

	SDL_PollEvent(&event);
	while (!done)
	{
        // skontroluj ci sme v menu : if menu else game
        if (!eman.getState())
        {        
            char ch[6];
            
            while ( SDL_PollEvent(&event)){}
            
            if (eman.getScore() > hiscore[9].score)
            {
                HiData hd;
                
                eman.chooseYourName(screen);
                hd.score = eman.getScore();
                strcpy(hd.name,eman.getName());
                hd.name[3]='\0';
                hiscore.push_back(hd);
                sort(hiscore.begin(),hiscore.end(),comparex);
                
                eman.setScore(0);
                
            }
            menu = iio.loadTransparentImage(MENU_PATH);
            for (int i = 0 ; i<=9; i++)
            {
                menu = utils.drawText(menu,hiscore[i].name,180,65+14*i);
                ut.itoa(hiscore[i].score,ch,10);
                menu = utils.drawText(menu,ch,230,65+14*i);            
            }
            
            utils.drawSprite(menu, screen, 0, 0, 0, 0, intro->w, intro->h);
            SDL_Flip(screen);
            int mn = eman.mainMenu();
            if (mn == 1)
            {  
               eman.setState(true);
               eman.prepareLevel(1);
            }
            else
            {
                done = 1;
            }
        }
 	    else
        {   
            // vykresli hornu listu
            eman.drawStats(screen);
            // vykresli hru        
            eman.playLevel(screen,time,charact,end_portal,bonus_blue,bonus_orange,bonus_red,bonus_green,enemy1,enemy2,enemy3);
            eman.moveEnemy(time);
        }
		
		while ( SDL_PollEvent(&event))
        { 
        
    		switch (event.type)
    		{
                case SDL_KEYDOWN:
                     
					if (event.key.keysym.sym == SDLK_ESCAPE)
						eman.setState(false);
						
					if (event.key.keysym.sym == SDLK_UP)
						eman.movePlayer('Y',false);
						
					if (event.key.keysym.sym == SDLK_DOWN)
						eman.movePlayer('Y',true);
		            
   					if (event.key.keysym.sym == SDLK_LEFT)
						eman.movePlayer('X',false);
						
					if (event.key.keysym.sym == SDLK_RIGHT)
						eman.movePlayer('X',true);
					
					break;
				
    
    			case SDL_JOYBUTTONDOWN:
                    switch(event.jbutton.button)
                    { 
        				case GP2X_BUTTON_SELECT:
            				eman.setState(false);
            				break;	
            				
        				case 0:
    						eman.movePlayer('Y',false);
    						break;	
    						
    					case 4:
    						eman.movePlayer('Y',true);
    						break;	
    		            
       					case 2:
    						eman.movePlayer('X',false);
    						break;	
    						
    					case 6:
    						eman.movePlayer('X',true);
    						break;	
                    }
    			    break;		
             }
        }
        
       	SDL_Flip(screen);
		SDL_Delay(50);
		time += 1;
        if ( time > 10000 ) time=0; 
		utils.drawSprite(bitmap, screen, 0, 0, 0, 0, bitmap->w, bitmap->h);
	}
	
	fout.open(HISCORE_PATH);    
    for (int i = 0 ; i<=9; i++)
    {
        fout<<hiscore[i].score<<endl;
        fout<<hiscore[i].name<<endl;
    }
    fout.close();
//GP2X    
    sync();

	SDL_Quit();
	
//GP2X
	chdir("/usr/gp2x");
	execl("/usr/gp2x/gp2xmenu", "/usr/gp2x/gp2xmenu", NULL);
	
	return 0;
}














